<?php

/**
 * @file
 * Provides an admin form code for vitals.
 */

/**
 * Provides the vitals config form.
 */
function vitals_admin_form($form, &$form_state) {
  module_load_include('inc', 'vitals');

  $form['#attached']['js'][] = drupal_get_path('module', 'vitals') . '/js/vitals_admin.js';

  $form['vitals_token'] = array(
    '#type' => 'hidden',
    '#value' => variable_get('vitals_token'),
    '#attributes' => array(
      'id' => 'js-hidden-token',
    ),
  );

  $form['vitals_copy_button'] = array(
    '#type' => 'submit',
    '#value' => t('Copy Current Token'),
    '#attributes' => array(
      'id' => 'js-copy-button',
    ),
  );

  $form['vitals_generate_button'] = array(
    '#type' => 'submit',
    '#value' => t('Generate New Token'),
    '#attributes' => array(
      'id' => 'js-generate-button',
    ),
    '#submit' => array('vitals_admin_form_generate_new_token'),
  );

  $form['vitals_unauthorized_action'] = array(
    '#type' => 'select',
    '#title' => t('Unauthorized Action'),
    '#description' => t('This allows you to change the behavior if the endpint is used without a valid token.'),
    '#default_value' => variable_get('vitals_unauthorized_action', VITALS_404),
    '#options' => array(
      VITALS_403 => t('403 - Forbidden'),
      VITALS_404 => t('404 - Not Found'),
    ),
  );

  $form['vitals_link'] = array(
    '#markup' => t('You can hit the vitals end point by clicking <a href="@url" target="_blank">here</a>.', array(
      '@url' => url(vitals_get_path()),
    )),
  );

  return system_settings_form($form);
}

/**
 * Generates a new token for the vitals module.
 */
function vitals_admin_form_generate_new_token($form, &$form_state) {
  module_load_include('inc', 'vitals');
  $token = vitals_generate_token();
  variable_set('vitals_token', $token);
  drupal_set_message(t('A new token has been generated.'));
}
